<?php

require_once 'config.php';
require_once 'auth.php';
require_once 'xml.php';


$help = "Usage: blogger_post.php -filename=FILENAME -subject=SUBJECT -tags=TAGS -blog=BLOG_LABEL\n";

for ($i=1; $i<count($argv); $i++) {
  list($op,$val) = explode("=", $argv[$i]);
  if (substr($op, 0, 1) == '-') {
    $op = substr($op,1);
    ${$op} = $val;
  }
}

if ($op == 'help') die($help);

if (!isset($filename) || !isset($subject) || !isset($tags) || !isset($blog)) {
	die ($help);
}

if (!isset($blogs) || !is_array($blogs)) {
	die ("Array of blogs is not defined in config.php. Please run blogger_info.php.\n");
}

if (!isset($blogs[$blog])) {
	die ("Blog ID for $blog is not defined in config.php.\n");
}
$blog_id = $blogs[$blog];

print "filename=$filename subject=$subject tags=$tags blog=$blog\n";

if (!file_exists($filename)) {
	die("Can't open file $filename.\n");
}
$content = @file_get_contents($filename);
if ($content == '') {
	die ("File $filename is empty.\n");
}
$content = str_replace("\n", "<br/>\n", $content);
$content = str_replace("&", "&amp;", $content);
$content = iconv('ISO-8859-1','UTF-8',$content); // this might not work with other encodings!!
$xml = create_xml($subject, $content, $tags);

$auth_token = auth($email, $passwd, 'blogger', $source);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "http://www.blogger.com/feeds/$blog_id/posts/default");
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("GData-Version: 2","Authorization: GoogleLogin auth=$auth_token","Content-Type: application/atom+xml"));
curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);

$response = curl_exec($ch);
curl_close($ch);

$data =  xml2array($response,1,'attribute');
//print_r($data);

if (is_array($data['entry']['link'])) {
	foreach ($data['entry']['link'] as $link){
		if ($link['attr']['rel'] == 'alternate') {
			$url = $link['attr']['href'];
			print "$url\n";
			break;
		}
	}
}

if (!isset($url)) {
	print "Post error!\n";
	if (!is_array($data)) {
		print "Possible reason: malformed HTML in $filename.\n";
	}
	print "Response from the server: $response\n";
}


function create_xml($subject, $content, $tags_)
{
	$tags = preg_split("/\s*\,\s*/", $tags_);
	$tags_str = '';
	foreach ($tags as $tag) {
		$tags_str .= "<category scheme=\"http://www.blogger.com/atom/ns#\" term=\"$tag\" />";
	}

$xml =<<<EOF
<entry xmlns='http://www.w3.org/2005/Atom'>
  <title type='text'>$subject</title>
  <content type='xhtml'>
	 $content
  </content>
	$tags_str
</entry>
EOF;

 return $xml;
}

?>
