<?php

require_once 'config.php';
require_once 'auth.php';
require_once 'xml.php';


$help = "Usage: get_post.php -filename=OUTPUT_FILENAME -blog=BLOG\n(BLOG: either tarot or scratch)\n";

for($i=1;$i<count($argv);$i++){
  list($op,$val) = explode("=",$argv[$i]);
  if(substr($op,0,1) == '-'){
    $op=substr($op,1);
    ${$op} = $val;
  }
}

if($op=='help')die($help);
if(!isset($filename) || !isset($blog)) {
	die($help);
}

if (!isset($blogs) || !is_array($blogs)) {
	die ("Array of blogs is not defined in config.php. Please run blogger_info.php.\n");
}

if (!isset($blogs[$blog])) {
	die ("Blog ID for $blog is not defined in config.php.\n");
}
$blog_id = $blogs[$blog];


$auth_token = auth($email, $passwd, 'blogger', $source);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "http://www.blogger.com/feeds/$blog_id/posts/default?max-results=1");
curl_setopt($ch, CURLOPT_POST, false);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("GData-Version: 2","Authorization: GoogleLogin auth=$auth_token"));

$response = curl_exec($ch);
curl_close($ch);
$data =  xml2array($response,1,'attribute');

$file = fopen("test.xml","w");
fputs($file,$response);
fclose($file);

$entry = $data['feed']['entry'];
$id = $entry['id']['value'];
$title = $entry['title']['value'];
$content = $entry['content']['value'];
foreach($entry['link'] as $link){
	if($link['attr']['rel']=='edit'){
		$edit_url = $link['attr']['href'];
		print "$edit_url\n";
		break;
	}
}

$tags = '';

foreach($entry['category'] as $category){
	foreach($category as $key=>$value){
		//		print "key=$key value=$value\n";
		if($key=='attr'){
			$tag = $category['attr']['term'];				
		}
		else if($key=='term'){
			$tag = $value;
		}
		if($tag != ""){
			$tags .= "$tag, ";
		}
	}
}

$tags = preg_replace("/,\s*$/","",$tags);
print "tags=$tags\n";

print "id=$id\nsubject=$title\n";
$content = preg_replace("/(<br)\s*(\/>)/","\n",$content);
$file = fopen($filename,"w");
fputs($file,$content);
fclose($file);

$command = "blogger_edit.php -filename=$filename -postid=\"$id\" -subject=\"$title\" -tags=\"$tags\" -blog=$blog";
print "\n$command\n";

?>
