<?php

require_once 'config.php';
require_once 'auth.php';
require_once 'xml.php';

$help = "Usage: picasa_upload.php -filename=FILENAME -album=ALBUM_LABEL\n";

for ($i=1; $i<count($argv); $i++) {
  list($op,$val) = explode("=", $argv[$i]);
  if (substr($op, 0, 1) == '-') {
    $op = substr($op,1);
    ${$op} = $val;
  }
}

if ($op == 'help') die($help);

if (!isset($filename) || !isset($album)) {
	die ($help);
}

if (!isset($albums) || !is_array($albums)) {
	die ("Array of albums is not defined in config.php. Please run picasa_info.php.\n");
}

if (!isset($albums[$album])) {
	die ("Album ID for $album is not defined in config.php.\n");
}
$album_id = $albums[$album];

if (!isset($title)) {
	$title = $filename;
}
if (!isset($summary)) {
	$summary = '';
}
print "filename=$filename album=$album\n";

if (!file_exists($filename)) {
	die("Can't open file $filename.\n");
}
$length = filesize($filename);
if ($length == 0) {
	die ("File $filename is empty.\n");
}
list($width, $height, $type) = getimagesize($filename);
$mimetype = image_type_to_mime_type($type);
if (!in_array($mimetype, array('image/gif','image/jpeg','image/png'))) {
	die("Invalid image type $mimetype for $filename\n");
}
$content = @file_get_contents($filename);

$auth_token = auth($email, $passwd, 'lh2', $source);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "http://picasaweb.google.com/data/feed/api/user/default/albumid/$album_id");
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("GData-Version: 2","Authorization: GoogleLogin auth=$auth_token","Content-Type: $mimetype","Slug: $filename"));
curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
$response = curl_exec($ch);
curl_close($ch);

$data =  xml2array($response,1,'attribute');
// print_r($data);

if (is_array($data)) {
	$url = $data['entry']['content']['attr']['src'];
	print "$url\n\n";

	$thumbnails = $data['entry']['media:group']['media:thumbnail'];
	$i=0;
	foreach($thumbnails as $thumbnail){
		$url_s = $thumbnail['attr']['url'];
		if($i==0){
			$thumbnail400 = str_replace("/s72/","/s400/",$url_s);
		}
		$i++;
		$width =  $thumbnail['attr']['width'];
		print "$url_s\n";
	}
	if ($width<400) {
		if (url_exists($thumbnail400)) {
			print "$thumbnail400\n\n";
			$a_href = a_href($thumbnail400, $url, $filename);
		}
	}
	else {
		$a_href = a_href($url_s, $url, $filename);
	}

	print "$a_href\n";
}

if (!isset($url)) {
	print "Upload error!\n";
	print "Response from the server: $response\n";
}

function a_href ($thumbnail, $url, $filename) {
	return "<a href=\"$url\"><img src=\"$thumbnail\" border=\"0\" alt=\"$filename\" /></a>";
}


function url_exists($url) {
	$ch = @curl_init($url);
	@curl_setopt($ch, CURLOPT_HEADER, TRUE);
	@curl_setopt($ch, CURLOPT_NOBODY, TRUE);
	@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, FALSE);
	@curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	$status = array();
	preg_match('/HTTP\/.* ([0-9]+) .*/', @curl_exec($ch) , $status);
	return ($status[1] == 200);
}

?>
